#!/usr/bin/perl


require "timelocal.pl";


while(<>) {

    if (/^\.PLAN/) {
	$plan=1;
	$size=$';
	$size =~ s/^\s*//;
	$size =~ s/\s*$//;
	($width,$height)=split(/\s+/,$size);
	open(SORT,"|sort > /tmp/graphproj$$");
	next;
    }
    if (/^\.EPLAN/) {
	$plan=0;
	close SORT;
	select STDOUT;
	&parse;
	&print_plan;
	next;
    }
    
    if ($plan==1) {

	select SORT;
	print;

    }

    if($plan == 0) {
	select STDOUT;
	print;
    }

}

sub parse {

    open(TMP,"</tmp/graphproj$$");

    $i=0;

    undef(@entry);
    undef(@lable);

    while(<TMP>) {

        chop;

        ($start,$stop,$text1,$text2)=split /\t+/;

	$start =~ /(\d\d)(\d\d)(\d\d)/;

	$yr1=$1;
	$mo1=$2;
	$da1=$3;

	$stop =~ /(\d\d)(\d\d)(\d\d)/;

	$yr2=$1;
	$mo2=$2;
	$da2=$3;

	$lable[$i]="$yr1\-$mo1\-$da1##$yr2\-$mo2\-$da2";

#	print $lable[$i]."\n";


# ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)

	$time1=&timelocal(1,1,1,$da1,$mo1-1,$yr1);


	$time2=&timelocal(1,1,1,$da2,$mo2-1,$yr2);

	$entry[$i]=join '##',$text1,$time1,$time2,$text2;


	$i++;

    }
    close TMP;
    unlink "/tmp/graphproj$$";
}


sub print_plan {

    my ($smindex,$bindex) = &extremes(@entry);

    ($a,$min,$c,$d) = split /##/,$entry[$smindex];
    ($a,$b,$max,$d) = split /##/,$entry[$bindex];

    &print_head ($width,$height);

    $k=$#entry;
    $boxheight=0.3*$height/$#entry;

    for($i=0;$i<=$#entry;$i++) {

	($a,$b,$c,$d) = split /##/,$entry[$i];

	$ypos=$k*$height/$#entry;
    
	$l=$width*($c-$b)/($max-$min);

	$xpos=$width*$b/($max-$min);

	print "box fill 0.1 width $l height $boxheight with .w at $xpos,$ypos\n";

	print "box invis \"$a\"  with .s at last box.w\n";

	($lab1,$lab2)=split /##/,$lable[$i];
	$ner=0.6;
	$upp=0.3;
	print "\"\\v\'$ner\'$lab1\\ \\v\'-$ner\'\" rjust with .se at 2nd last box.sw\n";
	print "\"\\v\'$ner\'\\ $lab2\\v\'-$ner\'\" ljust with .sw at 2nd last box.se\n";

#    print "box invis \"$d\" with .w at 2nd last box.e\n";
	print "\"\\ $d\" ljust at 2nd last box.e\n";

	$k--;

    }

    &print_foot;    
}


sub usage {
    print <<"END";

Usage: $0 options < file.in > file_out.pic

where file.in is a sorted list

yymmdd   yymmdd   text

END
}

sub print_head {
    local($wid,$hei)=@_;
print <<"END";
.EQ
delim \@\@
.EN
.PS $wid $hei
.ps 10
END
}

sub print_foot {
    print ".PE\n";
}

sub extremes {

    local(@arr)=@_;

    $small=100000;
    $big=0;

    for ($i=0;$i<=$#arr;$i++) {

	($t,$s,$b) = split /##/,$arr[$i];

	if ($small > $s ) {
	    $small = $s;
	    $smindex = $i;
	}

	if ($big < $b ) {
	    $big = $b;
	    $bindex = $i;
	}
    }

    return ($smindex,$bindex);

}
